# Java alkalmazsok, I. ZH #

* **Flv:** 2010-2011-II
* **Csoport:** IP-bJAG/1
* **Dtum:** 2012.03.19., 16:00-18:00

# Virtulis fjlrendszer #

Ksztsnk egy egyszer virtulis fjlrendszer reprezentcit Javaban!

A fjlrendszer komponensei egyelre csak fjlok s knyvtrak lehetnek.

* A fjlok rendelkeznek szveges tartalommal.
* Egy knyvtr tetszleges szm egyedi nev komponenst tartalmazhat.

Minden knyvtr rendelkezik egy szlknyvtrral (kivve a gykrknyvtrat).

## Megvalstand szolgltatsok ##

A megolds ellenrzshez a kvetkez tesztfjl hasznland:

* [FileSystemTest.java](FileSystemTest.java)

Megjegyzsek:

* Az egyes tesztblokkokat megjegyzsbe lehet tenni.
* A `dumpExceptions` vltoz igazra lltsa segthet a hibk feldertsben.
* A fjlban tallhat `import` utastsok egyrtelmv teszik a
  csomagszerkezetet.

### Kettesrt ###

Albb tallhat hrom interfszdefinci, ezekhez kell konkrt megvalstst
adni:

* [IEntry.java](IEntry.java)
* [IFile.java](IFile.java)
* [IFolder.java](IFolder.java)

A megvalstand funkcik a kvetkezk:

* `IEntry`: minden fjlrendszer komponens se (azaz a fjloknak is, s a
  knyvtraknak is). Az albbi funkcikkal rendelkezik:
  * `String getName()`: Megadja az adott komponens (fjl vagy knyvtr)
    nevt.
  * `IFolder getParent()`: Megadja a tartalmaz knyvtr pldnyt
    (gykrknyvtr esetn ez legyen `null`).
  * `int size()`: Megadja az adott komponens mrett (fjlok esetn ez
    legyen a tartalmazott szveg mrete, egybknt 0).
  * `IFolder getRoot()`: Megadja a fjlrendszer gykrknyvtrt.
* `IFile`: A fjloknak egyszer szveges tartalmuk van, amely lekrdezhet
  a `String getContent()` fggvnnyel.
* `IFolder`: Kontner, amely jabb fjlokat vagy knyvtrakat tartalmazhat.
  A szolgltatsai a kvetkezk:
  * `boolean isEmptyFolder()`: Megadja, hogy az adott knyvtr res-e
    (azaz azt, hogy van-e benne msik knyvtr vagy fjl).
  * `boolean isRootFolder()`: Igaz, ha az adott knyvtr megegyezik a
    gykrknyvtrral.
  * `Collection<IEntry> entries()`: Megadja a knyvtr ltal tartalmazott
    komponenseket (tetszleges adatszerkezettel megoldhatod).
  * `void add(IEntry entry)`: Knyvtrhoz j komponens hozzadsa.
  * `void remove(IEntry entry)`: Knyvtrbl komponens trlse.
  * `boolean containsEntry(IEntry entry)`: Megadja, hogy a knyvtr
    tartalmazza-e a megadott komponenst.

Ksztsd el teht a fenti interfszeket megvalst `Entry`, `File` s `Folder`
osztlyokat! Mind a `File`, mind a `Folder` szrmazzon az `Entry` *absztrakt*
osztlybl!

A konkrt megvalstsod, az `Entry` osztly *statikus adattagknt* tartalmazza
a gykrknyvtrat, amit a kvetkezhz hasonl mdon lehessen ltrehozni:

	public static IFolder createRootFolder(final String name) {
		final Folder root = new Folder( null, name );
		Entry.root = root;
		return root;
	}

Az osztlyok a kvetkez konstruktorokkal rendelkezzenek:

* `public Folder(final IFolder parent, final String name)`, amely belltja a
  knyvtr szlknyvtrt, valamint az adott knyvtr nevt.
* `public File(final IFolder parent, final String name, final String content)`,
  amely belltja a fjl szlknyvtrt, nevt, valamint megadja a tartalmt
  is.

Mindkt esetben adjuk hozz a ltrejv osztly pldnyt (`this`) a
szlknyvtrhoz az `add()` fggvnyen keresztl!

### +1 jegy ###

Valstsd meg a kvetkez funkcikat, amelyeket az `IEntry` interfsz r el!

* `void delete()`: A komponens trlse.
* `void moveTo(IFolder folder)`: A komponens thelyezse a megadott knyvtrba.
* `void rename(String newName)`: A komponens tnevezse.

### +1 jegy ###

Valstsd meg a kvetkez, bejrsokkal kapcsolatos funkcikat!

* Az `IEntry` ltal definilt `String getAbsolutePath()` fggvny adja meg a
  teljes elrsi utat az adott komponenshez. A szepartor karakter legyen a `/`.
* Kszts egy `filesystem.Utils` osztlyt, amely az `int totalSizeOf(IFolder root)`
  statikus fggvnnyel kpes meghatrozni a megadott knyvtr teljes mrett
  (azaz a benne lv fjlok, valamint az alknyvtraiban lv fjlok mretnek
  sszegt).

### +1 jegy ###

* Kszts egy `filesystem.Utils` osztlyt, amely kpes meghatrozni egy adott
  knyvtrban tallhat fjlok kzl a legkisebb s legnagyobb fjl mrett,
  valamint megadja a fjlok rendezett listjt (ezeknek nem kell rekurzv
  mveleteknek lennik).

## Megjegyzsek ##

* Ahol a feladatlers flrerthetsgre ad okot, ott minden sszer felttelezst
elfogadunk (*ezt mindenkpp jelezd*).
* Az interfszeket (amennyiben szksged van r) tetszlegesen bvtheted!
* Vegyk szre, hogy (*habr ltalban faknt emlegetik*), a fjlrendszer
  igazbl nem egy fa adatszerkezet: az egy grf (krkkel, prhuzamos- s
  huroklekkel)!
* A megvalstand fjlrendszer csak virtulis, azaz nem kell tnyleges fjlokat
  ltrehozni!
